/**
 * DefaultMonGraphModel.java
 * LO42 - TP5 - Recherche de chemin de poids minimal et utilisation de jgraph
 * Martin ROLLAND - Laurent COUVIDOU
 */

import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.*;
import java.util.*;

public class DefaultMonGraphModel
	extends DefaultGraphModel
	implements MonGraphModel {
	
	public int degrePlus(DefaultGraphCell c) {
		int i = 0;
		Port p = (Port) getChild(c, 0);
		Iterator it = p.edges();
		while (it.hasNext()) {
			it.next();
			i++;
		}
		return i;
	}

	public DefaultGraphCell iemeSucc(int i, DefaultGraphCell c) {
		Port p = (Port) getChild(c, 0);
		DefaultPort p1;
		Iterator it = p.edges();
		while (i > 0 && it.hasNext()) {
			i--;
			it.next();
		}
		Edge e = (Edge) (it.next());
		if ((p1 = (DefaultPort) e.getSource()) == p)
			p1 = (DefaultPort) e.getTarget();
		return (DefaultGraphCell) p1.getParent();
		//return (DefaultGraphCell) getParent(p1);
	}
	
	public List listeSucc(DefaultGraphCell c) {
		// on suppose qu'il n'y a qu'un port par sommet
		List succs = new ArrayList();
		Port p = (Port) getChild(c, 0);
		DefaultPort p1;
		Iterator it = p.edges();
		while (it.hasNext()) {
			Edge e = (Edge) (it.next());
			if ((p1 = (DefaultPort) e.getSource()) == p)
				p1 = (DefaultPort) e.getTarget();
			succs.add((DefaultGraphCell) p1.getParent());
		}
		return succs;
	}
	
//	public DefaultGraphCell[] listeSucc2(DefaultGraphCell c) {
//		// on suppose qu'il n'y a qu'un port par sommet
//		DefaultGraphCell[] succs=new DefaultGraphCell(150);
//		int i=0;
//		Port p = (Port) getChild(c, 0);
//		DefaultPort p1;
//		Iterator it = p.edges();
//		while (it.hasNext()) {
//			Edge e = (Edge) (it.next());
//			if ((p1 = (DefaultPort) e.getSource()) == p)
//				p1 = (DefaultPort) e.getTarget();
//			succs[i]=(DefaultGraphCell)p1.getParent();
//			i++;
//		}
//		return succs;
//	}

	public List listeSom() {
		Vector soms = new Vector(); //ou LinkedList
		Object o[] = DefaultGraphModel.getRoots(this);
		for (int i = 0; i < o.length - 1; i++)
			if (o[i].getClass() == DefaultGraphCell.class)
				soms.add(o[i]);
		return soms;
	}

	public int ordre() {
		Vector soms = new Vector(); //ou LinkedList
		Object o[] = DefaultGraphModel.getRoots(this);
		for (int i = 0; i < o.length - 1; i++)
			if (o[i].getClass() == DefaultGraphCell.class)
				soms.add(o[i]);
		return soms.size();
	}
		
}